import * as i0 from '@angular/core';
import { Component, Input, ViewChild, HostListener, EventEmitter, SecurityContext, Output, NgModule } from '@angular/core';
import * as i1$1 from '@angular/platform-browser';
import * as i2$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i2 from '@angular/cdk/clipboard';
import { ClipboardModule } from '@angular/cdk/clipboard';
import * as i3 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i4 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';

const _c0$1 = ["tooltip"];
class TdCopyCodeButtonComponent {
    constructor() {
        this.copyCodeToClipboard = false;
        /**
         * copyCodeTooltips?: ICopyCodeTooltips
         *
         * Tooltips for copy button to copy and upon copying.
         */
        this.copyCodeTooltips = {};
    }
    get copyTooltip() {
        return (this.copyCodeTooltips && this.copyCodeTooltips.copy) || 'Copy';
    }
    get copiedTooltip() {
        return (this.copyCodeTooltips && this.copyCodeTooltips.copied) || 'Copied';
    }
    textCopied(event) {
        if (event) {
            this.tooltip.hide();
            this.tooltip.message = this.copiedTooltip;
            this.tooltip.show();
        }
    }
    initializeTooltip() {
        setTimeout(() => {
            this.tooltip.message = this.copyTooltip;
        }, 200);
    }
}
/** @nocollapse */ /** @nocollapse */ TdCopyCodeButtonComponent.ɵfac = function TdCopyCodeButtonComponent_Factory(t) { return new (t || TdCopyCodeButtonComponent)(); };
/** @nocollapse */ /** @nocollapse */ TdCopyCodeButtonComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TdCopyCodeButtonComponent, selectors: [["td-copy-code-button"]], viewQuery: function TdCopyCodeButtonComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(_c0$1, 5);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.tooltip = _t.first);
        }
    }, hostBindings: function TdCopyCodeButtonComponent_HostBindings(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵlistener("mouseleave", function TdCopyCodeButtonComponent_mouseleave_HostBindingHandler() { return ctx.initializeTooltip(); });
        }
    }, inputs: { copiedContent: "copiedContent", copyCodeToClipboard: "copyCodeToClipboard", copyCodeTooltips: "copyCodeTooltips" }, decls: 4, vars: 2, consts: [["mat-icon-button", "", 1, "copy-button", 3, "cdkCopyToClipboard", "matTooltip", "cdkCopyToClipboardCopied"], ["tooltip", "matTooltip"], ["role", "img"]], template: function TdCopyCodeButtonComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "button", 0, 1);
            i0.ɵɵlistener("cdkCopyToClipboardCopied", function TdCopyCodeButtonComponent_Template_button_cdkCopyToClipboardCopied_0_listener($event) { return ctx.textCopied($event); });
            i0.ɵɵelementStart(2, "mat-icon", 2);
            i0.ɵɵtext(3, "content_copy");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵproperty("cdkCopyToClipboard", ctx.copiedContent)("matTooltip", ctx.copyTooltip);
        }
    }, directives: [i1.MatButton, i2.CdkCopyToClipboard, i3.MatTooltip, i4.MatIcon], styles: [""] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdCopyCodeButtonComponent, [{
            type: Component,
            args: [{ selector: 'td-copy-code-button', template: "<button\n  mat-icon-button\n  [cdkCopyToClipboard]=\"copiedContent\"\n  class=\"copy-button\"\n  [matTooltip]=\"copyTooltip\"\n  #tooltip=\"matTooltip\"\n  (cdkCopyToClipboardCopied)=\"textCopied($event)\"\n>\n  <mat-icon role=\"img\">content_copy</mat-icon>\n</button>\n", styles: [""] }]
        }], null, { copiedContent: [{
                type: Input
            }], copyCodeToClipboard: [{
                type: Input
            }], copyCodeTooltips: [{
                type: Input
            }], tooltip: [{
                type: ViewChild,
                args: ['tooltip']
            }], initializeTooltip: [{
                type: HostListener,
                args: ['mouseleave']
            }] });
})();

const _c0 = ["highlightComponent"];
const _c1 = ["copyComponent"];
const _c2 = ["tooltip"];
function TdHighlightComponent_div_4_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "div", null, 2);
        i0.ɵɵelement(2, "td-copy-code-button", 3);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("copiedContent", ctx_r1.copyContent)("copyCodeToClipboard", ctx_r1.copyCodeToClipboard)("copyCodeTooltips", ctx_r1.copyCodeTooltips);
    }
}
const _c3 = ["*"];
/* tslint:disable-next-line */
let hljs = require('highlight.js/lib');
class TdHighlightComponent {
    constructor(_renderer, _elementRef, _domSanitizer, cdr) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this._domSanitizer = _domSanitizer;
        this.cdr = cdr;
        this._initialized = false;
        this._lang = 'typescript';
        /**
         * copyCodeToClipboard?: boolean
         *
         * Display copy button on code snippets to copy code to clipboard.
         */
        this.copyCodeToClipboard = false;
        /**
         * copyCodeTooltips?: ICopyCodeTooltips
         *
         * Tooltips for copy button to copy and upon copying.
         */
        this.copyCodeTooltips = {};
        /**
         * contentReady?: function
         * Event emitted after the highlight content rendering is finished.
         */
        this.contentReady = new EventEmitter();
    }
    /**
     * content?: string
     *
     * Code content to be parsed as highlighted html.
     * Used to load data dynamically.
     *
     * e.g. `.html`, `.ts` , etc.
     */
    set content(content) {
        this._content = content;
        if (this._initialized) {
            this._loadContent(this._content);
        }
    }
    /**
     * lang?: string
     *
     * Language of the code content to be parsed as highlighted html.
     * Defaults to `typescript`
     *
     * e.g. `typescript`, `html` , etc.
     */
    set codeLang(lang) {
        this.setLanguage(lang);
    }
    /** @deprecated - removed completely @4.0.0 */
    set lang(lang) {
        // tslint:disable-next-line: no-console
        console.warn('DEPRECATION WARNING: switch to codeLang attribute as lang attribute is deprecated.');
        this.setLanguage(lang);
    }
    ngAfterViewChecked() {
        this.cdr.detectChanges();
    }
    ngAfterViewInit() {
        if (!this._content) {
            this._loadContent(this.highlightComp.nativeElement.textContent);
        }
        else {
            this._loadContent(this._content);
        }
        this._initialized = true;
    }
    setLanguage(lang) {
        if (!lang) {
            throw new Error('Error: language attribute must be defined in TdHighlightComponent.');
        }
        this._lang = lang;
        if (this._initialized) {
            this._loadContent(this._content);
        }
    }
    /**
     * General method to parse a string of code into HTML Elements and load them into the container
     */
    _loadContent(code) {
        if (code && code.trim().length > 0) {
            // Clean container
            this._renderer.setProperty(this._elementRef.nativeElement, 'innerHTML', '');
            // Parse html string into actual HTML elements.
            this._elementFromString(this._render(code));
            if (this.copyCodeToClipboard) {
                this._renderer.appendChild(this._elementRef.nativeElement, this.copyComp.nativeElement);
            }
        }
        this.contentReady.emit();
    }
    _elementFromString(codeStr) {
        // Renderer2 doesnt have a parsing method, so we have to sanitize and use [innerHTML]
        // to parse the string into DOM element for now.
        const preElement = this._renderer.createElement('pre');
        this._renderer.appendChild(this._elementRef.nativeElement, preElement);
        const codeElement = this._renderer.createElement('code');
        this._renderer.appendChild(preElement, codeElement);
        // Set .highlight class into <code> element
        this._renderer.addClass(codeElement, 'highlight');
        codeElement.innerHTML = this._domSanitizer.sanitize(SecurityContext.HTML, codeStr);
        return preElement;
    }
    _render(contents) {
        // Trim leading and trailing newlines
        contents = contents.replace(/^(\s|\t)*\n+/g, '').replace(/(\s|\t)*\n+(\s|\t)*$/g, '');
        // Split markup by line characters
        let lines = contents.split('\n');
        // check how much indentation is used by the first actual code line
        const firstLineWhitespace = lines[0].match(/^(\s|\t)*/)[0];
        // Remove all indentation spaces so code can be parsed correctly
        const startingWhitespaceRegex = new RegExp('^' + firstLineWhitespace);
        lines = lines.map(function (line) {
            return line
                .replace('=""', '') // remove empty values
                .replace(startingWhitespaceRegex, '')
                .replace(/\s+$/, ''); // remove trailing white spaces
        });
        const codeToParse = lines
            .join('\n')
            .replace(/\{ \{/gi, '{{')
            .replace(/\} \}/gi, '}}')
            .replace(/&lt;/gi, '<')
            .replace(/&gt;/gi, '>'); // replace with < and > to render HTML in Angular
        this.copyContent = codeToParse;
        // Parse code with highlight.js depending on language
        const highlightedCode = hljs.highlight(this._lang, codeToParse, true);
        highlightedCode.value = highlightedCode.value
            .replace(/=<span class="hljs-value">""<\/span>/gi, '')
            .replace('<head>', '')
            .replace('<head/>', '');
        return highlightedCode.value;
    }
}
/** @nocollapse */ /** @nocollapse */ TdHighlightComponent.ɵfac = function TdHighlightComponent_Factory(t) { return new (t || TdHighlightComponent)(i0.ɵɵdirectiveInject(i0.Renderer2), i0.ɵɵdirectiveInject(i0.ElementRef), i0.ɵɵdirectiveInject(i1$1.DomSanitizer), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
/** @nocollapse */ /** @nocollapse */ TdHighlightComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: TdHighlightComponent, selectors: [["td-highlight"]], viewQuery: function TdHighlightComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(_c0, 5);
            i0.ɵɵviewQuery(_c1, 5);
            i0.ɵɵviewQuery(_c2, 5);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.highlightComp = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.copyComp = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.tooltip = _t.first);
        }
    }, inputs: { content: "content", copyCodeToClipboard: "copyCodeToClipboard", copyCodeTooltips: "copyCodeTooltips", codeLang: "codeLang", lang: "lang" }, outputs: { contentReady: "contentReady" }, ngContentSelectors: _c3, decls: 5, vars: 1, consts: [["highlightComponent", ""], [4, "ngIf"], ["copyComponent", ""], [3, "copiedContent", "copyCodeToClipboard", "copyCodeTooltips"]], template: function TdHighlightComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div");
            i0.ɵɵelementStart(1, "div", null, 0);
            i0.ɵɵprojection(3);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(4, TdHighlightComponent_div_4_Template, 3, 3, "div", 1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(4);
            i0.ɵɵproperty("ngIf", ctx.copyCodeToClipboard);
        }
    }, directives: [i2$1.NgIf, TdCopyCodeButtonComponent], styles: ["[_nghost-%COMP%]    {overflow-x:auto;padding:16px;display:-ms-flexbox;display:flex}[_nghost-%COMP%]     pre, [_nghost-%COMP%]     code, [_nghost-%COMP%]     .highlight{font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace}[_nghost-%COMP%]     pre{display:block;overflow-x:auto;padding:0;margin:0;background:transparent;font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace;line-height:1.45;-moz-tab-size:2;-o-tab-size:2;tab-size:2;-webkit-font-smoothing:auto;-webkit-text-size-adjust:none;-moz-text-size-adjust:none;text-size-adjust:none;position:relative;border-radius:2px;font-size:.8rem;width:100%}[_nghost-%COMP%]     code{margin:0;padding:0;overflow-wrap:break-word;white-space:pre-wrap}[_nghost-%COMP%]     .highlight{display:block;overflow-wrap:break-word;line-height:1.5;margin:0}[_nghost-%COMP%]     .copy-button{border:none;background:inherit;margin-top:-8px;margin-right:-8px}"] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdHighlightComponent, [{
            type: Component,
            args: [{ selector: 'td-highlight', template: "<div>\n  <div #highlightComponent>\n    <ng-content></ng-content>\n  </div>\n\n  <div #copyComponent *ngIf=\"copyCodeToClipboard\">\n    <td-copy-code-button\n      [copiedContent]=\"copyContent\"\n      [copyCodeToClipboard]=\"copyCodeToClipboard\"\n      [copyCodeTooltips]=\"copyCodeTooltips\"\n    ></td-copy-code-button>\n  </div>\n</div>\n", styles: [":host ::ng-deep{overflow-x:auto;padding:16px;display:-ms-flexbox;display:flex}:host ::ng-deep pre,:host ::ng-deep code,:host ::ng-deep .highlight{font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace}:host ::ng-deep pre{display:block;overflow-x:auto;padding:0;margin:0;background:transparent;font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace;line-height:1.45;-moz-tab-size:2;-o-tab-size:2;tab-size:2;-webkit-font-smoothing:auto;-webkit-text-size-adjust:none;-moz-text-size-adjust:none;text-size-adjust:none;position:relative;border-radius:2px;font-size:.8rem;width:100%}:host ::ng-deep code{margin:0;padding:0;overflow-wrap:break-word;white-space:pre-wrap}:host ::ng-deep .highlight{display:block;overflow-wrap:break-word;line-height:1.5;margin:0}:host ::ng-deep .copy-button{border:none;background:inherit;margin-top:-8px;margin-right:-8px}\n"] }]
        }], function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: i1$1.DomSanitizer }, { type: i0.ChangeDetectorRef }]; }, { content: [{
                type: Input,
                args: ['content']
            }], copyCodeToClipboard: [{
                type: Input
            }], copyCodeTooltips: [{
                type: Input
            }], codeLang: [{
                type: Input,
                args: ['codeLang']
            }], lang: [{
                type: Input
            }], contentReady: [{
                type: Output
            }], highlightComp: [{
                type: ViewChild,
                args: ['highlightComponent']
            }], copyComp: [{
                type: ViewChild,
                args: ['copyComponent']
            }], tooltip: [{
                type: ViewChild,
                args: ['tooltip']
            }] });
})();

class CovalentHighlightModule {
}
/** @nocollapse */ /** @nocollapse */ CovalentHighlightModule.ɵfac = function CovalentHighlightModule_Factory(t) { return new (t || CovalentHighlightModule)(); };
/** @nocollapse */ /** @nocollapse */ CovalentHighlightModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: CovalentHighlightModule });
/** @nocollapse */ /** @nocollapse */ CovalentHighlightModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ imports: [[CommonModule, ClipboardModule, MatIconModule, MatTooltipModule, MatButtonModule]] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(CovalentHighlightModule, [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, ClipboardModule, MatIconModule, MatTooltipModule, MatButtonModule],
                    declarations: [TdHighlightComponent, TdCopyCodeButtonComponent],
                    exports: [TdHighlightComponent],
                }]
        }], null, null);
})();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(CovalentHighlightModule, { declarations: [TdHighlightComponent, TdCopyCodeButtonComponent], imports: [CommonModule, ClipboardModule, MatIconModule, MatTooltipModule, MatButtonModule], exports: [TdHighlightComponent] }); })();

/**
 * Generated bundle index. Do not edit.
 */

export { CovalentHighlightModule, TdCopyCodeButtonComponent, TdHighlightComponent };
//# sourceMappingURL=covalent-highlight.mjs.map
